From 70e5bfb03548c513ef0ba39bd4f6644d6d184ee0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 19 2020 22:45:36 +0000
Subject: [PATCH 1456/2232] Perform exhaustive type matching for is_unsized check


This way we won't forget to touch this code when introducing some new
binding.

---

diff --git a/syntax/check.rs b/syntax/check.rs
index 53dd843..b0ac66e 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -402,12 +402,20 @@ fn check_reserved_name(cx: &mut Check, ident: &Ident) {
 }
 
 fn is_unsized(cx: &mut Check, ty: &Type) -> bool {
-    let ident = match ty {
-        Type::Ident(ident) => &ident.rust,
+    match ty {
+        Type::Ident(ident) => {
+            let ident = &ident.rust;
+            ident == CxxString || is_opaque_cxx(cx, ident) || cx.types.rust.contains(ident)
+        }
         Type::CxxVector(_) | Type::Slice(_) | Type::Void(_) => return true,
-        _ => return false,
-    };
-    ident == CxxString || is_opaque_cxx(cx, ident) || cx.types.rust.contains(ident)
+        Type::RustBox(_)
+        | Type::RustVec(_)
+        | Type::UniquePtr(_)
+        | Type::Ref(_)
+        | Type::Str(_)
+        | Type::Fn(_)
+        | Type::SliceRefU8(_) => return false,
+    }
 }
 
 fn is_opaque_cxx(cx: &mut Check, ty: &Ident) -> bool {

